#include <cassert>

auto digit_sum(auto num, auto base) {
	// preconditions
	assert(num >= 0 && base >= 2);

	decltype(num) result = 0;
	while (num > 0) {
		result += num % base;
		num /= base;
	}
	return result;
}

int main() {
	assert(digit_sum(42, 10) == 6);
	assert(digit_sum(1337, 10) == 14);
	assert(digit_sum(1337, 2) == 6);
	assert(digit_sum(1330, 11) == 30);
}
